"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useBootstrapConfirm = exports.BootstrapUseConfirm = exports.BootstrapConfirmProvider = exports.BootstrapConfirm = void 0;
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _reactstrap = require("reactstrap");
var _excluded = ["confirmFn"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var BootstrapConfirmContext = /*#__PURE__*/(0, _react.createContext)({
  showModal: function showModal() {
    return void 0;
  },
  closeModal: function closeModal() {
    return void 0;
  }
});
var BootstrapConfirmProvider = exports.BootstrapConfirmProvider = function BootstrapConfirmProvider(_ref) {
  var children = _ref.children;
  var _React$useState = _react["default"].useState(null),
    _React$useState2 = (0, _slicedToArray2["default"])(_React$useState, 2),
    Modal = _React$useState2[0],
    setModal = _React$useState2[1];
  var _React$useState3 = _react["default"].useState(false),
    _React$useState4 = (0, _slicedToArray2["default"])(_React$useState3, 2),
    modalOpened = _React$useState4[0],
    setModalOpened = _React$useState4[1];
  var showModal = function showModal(modal) {
    setModalOpened(true);
    setModal(modal);
  };
  var closeModal = function closeModal() {
    setModalOpened(false);
    setTimeout(function () {
      setModal(null);
    }, 300);
  };
  return /*#__PURE__*/_react["default"].createElement(BootstrapConfirmContext.Provider, {
    value: {
      showModal: showModal,
      closeModal: closeModal
    }
  }, children, Modal && /*#__PURE__*/_react["default"].createElement(Modal, {
    modalOpened: modalOpened
  }));
};
var useBootstrapConfirm = exports.useBootstrapConfirm = function useBootstrapConfirm() {
  var context = (0, _react.useContext)(BootstrapConfirmContext);
  if (!context) {
    throw new Error("useBootstrapConfirm must be used within a BootstrapConfirmProvider");
  }
  return context;
};
var BootstrapUseConfirm = exports.BootstrapUseConfirm = function BootstrapUseConfirm() {
  var _useBootstrapConfirm = useBootstrapConfirm(),
    showModal = _useBootstrapConfirm.showModal,
    closeModal = _useBootstrapConfirm.closeModal;
  var confirmFn = function confirmFn(_ref2) {
    var title = _ref2.title,
      okText = _ref2.okText,
      cancelText = _ref2.cancelText,
      onOk = _ref2.onOk;
    var onClickOk = function onClickOk() {
      closeModal();
      onOk === null || onOk === void 0 || onOk();
    };
    var onClickCancel = function onClickCancel() {
      closeModal();
    };
    showModal(function () {
      return function () {
        var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          modalOpened = _ref3.modalOpened;
        return /*#__PURE__*/_react["default"].createElement(_reactstrap.Modal, {
          isOpen: modalOpened === undefined ? true : modalOpened,
          toggle: closeModal
        }, /*#__PURE__*/_react["default"].createElement(_reactstrap.ModalBody, null, title), /*#__PURE__*/_react["default"].createElement(_reactstrap.ModalFooter, null, /*#__PURE__*/_react["default"].createElement(_reactstrap.Button, {
          color: "danger",
          onClick: onClickOk
        }, okText), /*#__PURE__*/_react["default"].createElement(_reactstrap.Button, {
          color: "secondary",
          onClick: onClickCancel
        }, cancelText)));
      };
    });
  };
  return confirmFn;
};
var BootstrapConfirm = exports.BootstrapConfirm = function BootstrapConfirm(_ref4) {
  var confirmFn = _ref4.confirmFn,
    renderOptions = (0, _objectWithoutProperties2["default"])(_ref4, _excluded);
  confirmFn === null || confirmFn === void 0 || confirmFn(renderOptions);
};