"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireDefault(require("react"));
var _reactstrap = require("reactstrap");
var _ui = require("@react-awesome-query-builder/ui");
var _Utils$NumberFormat = _ui.Utils.NumberFormat,
  NumericFormat = _Utils$NumberFormat.NumericFormat,
  getNumberFormatProps = _Utils$NumberFormat.getNumberFormatProps;
var _default = exports["default"] = function _default(props) {
  var value = props.value,
    setValue = props.setValue,
    readonly = props.readonly,
    placeholder = props.placeholder,
    min = props.min,
    max = props.max,
    customProps = props.customProps;
  var numericFormatProps = getNumberFormatProps(props);
  var formattedValue = value == undefined ? "" : value;
  var isValid = value != undefined && (max == undefined || value <= max) && (min == undefined || value >= min);
  var handleChange = function handleChange(values) {
    var val = values.floatValue;
    setValue(val === undefined ? null : val);
  };
  return /*#__PURE__*/_react["default"].createElement(NumericFormat, (0, _extends2["default"])({
    bsSize: "sm",
    invalid: value != undefined && !isValid,
    customInput: _reactstrap.Input,
    value: formattedValue,
    placeholder: placeholder,
    disabled: readonly,
    onValueChange: handleChange
  }, customProps, numericFormatProps));
};