import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
var _excluded = ["confirmFn"];
import React, { createContext, useContext } from "react";
import { Button, Modal, ModalBody, ModalFooter } from "reactstrap";
var BootstrapConfirmContext = /*#__PURE__*/createContext({
  showModal: function showModal() {
    return void 0;
  },
  closeModal: function closeModal() {
    return void 0;
  }
});
export var BootstrapConfirmProvider = function BootstrapConfirmProvider(_ref) {
  var children = _ref.children;
  var _React$useState = React.useState(null),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    Modal = _React$useState2[0],
    setModal = _React$useState2[1];
  var _React$useState3 = React.useState(false),
    _React$useState4 = _slicedToArray(_React$useState3, 2),
    modalOpened = _React$useState4[0],
    setModalOpened = _React$useState4[1];
  var showModal = function showModal(modal) {
    setModalOpened(true);
    setModal(modal);
  };
  var closeModal = function closeModal() {
    setModalOpened(false);
    setTimeout(function () {
      setModal(null);
    }, 300);
  };
  return /*#__PURE__*/React.createElement(BootstrapConfirmContext.Provider, {
    value: {
      showModal: showModal,
      closeModal: closeModal
    }
  }, children, Modal && /*#__PURE__*/React.createElement(Modal, {
    modalOpened: modalOpened
  }));
};
export var useBootstrapConfirm = function useBootstrapConfirm() {
  var context = useContext(BootstrapConfirmContext);
  if (!context) {
    throw new Error("useBootstrapConfirm must be used within a BootstrapConfirmProvider");
  }
  return context;
};
export var BootstrapUseConfirm = function BootstrapUseConfirm() {
  var _useBootstrapConfirm = useBootstrapConfirm(),
    showModal = _useBootstrapConfirm.showModal,
    closeModal = _useBootstrapConfirm.closeModal;
  var confirmFn = function confirmFn(_ref2) {
    var title = _ref2.title,
      okText = _ref2.okText,
      cancelText = _ref2.cancelText,
      onOk = _ref2.onOk;
    var onClickOk = function onClickOk() {
      closeModal();
      onOk === null || onOk === void 0 || onOk();
    };
    var onClickCancel = function onClickCancel() {
      closeModal();
    };
    showModal(function () {
      return function () {
        var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          modalOpened = _ref3.modalOpened;
        return /*#__PURE__*/React.createElement(Modal, {
          isOpen: modalOpened === undefined ? true : modalOpened,
          toggle: closeModal
        }, /*#__PURE__*/React.createElement(ModalBody, null, title), /*#__PURE__*/React.createElement(ModalFooter, null, /*#__PURE__*/React.createElement(Button, {
          color: "danger",
          onClick: onClickOk
        }, okText), /*#__PURE__*/React.createElement(Button, {
          color: "secondary",
          onClick: onClickCancel
        }, cancelText)));
      };
    });
  };
  return confirmFn;
};
export var BootstrapConfirm = function BootstrapConfirm(_ref4) {
  var confirmFn = _ref4.confirmFn,
    renderOptions = _objectWithoutProperties(_ref4, _excluded);
  confirmFn === null || confirmFn === void 0 || confirmFn(renderOptions);
};