import _extends from "@babel/runtime/helpers/extends";
import React from "react";
import { Input } from "reactstrap";
import { Utils } from "@react-awesome-query-builder/ui";
var _Utils$NumberFormat = Utils.NumberFormat,
  NumericFormat = _Utils$NumberFormat.NumericFormat,
  getNumberFormatProps = _Utils$NumberFormat.getNumberFormatProps;
export default (function (props) {
  var value = props.value,
    setValue = props.setValue,
    readonly = props.readonly,
    placeholder = props.placeholder,
    min = props.min,
    max = props.max,
    customProps = props.customProps;
  var numericFormatProps = getNumberFormatProps(props);
  var formattedValue = value == undefined ? "" : value;
  var isValid = value != undefined && (max == undefined || value <= max) && (min == undefined || value >= min);
  var handleChange = function handleChange(values) {
    var val = values.floatValue;
    setValue(val === undefined ? null : val);
  };
  return /*#__PURE__*/React.createElement(NumericFormat, _extends({
    bsSize: "sm",
    invalid: value != undefined && !isValid,
    customInput: Input,
    value: formattedValue,
    placeholder: placeholder,
    disabled: readonly,
    onValueChange: handleChange
  }, customProps, numericFormatProps));
});